'---------------------------------------------------------------------------- 1
'
'                             Tsr Calculator V1.3
'                              By Randall L Glass
'                                Copyright 2001
'
'----------------------------------------------------------------------------
$IF 0

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

------------------------------------------------------------------------------

    The Author can be contacted at: rlglass@yahoo.com. Or:

    Randall Glass Software
    RR1,Box 248B
    McLeansboro,IL
    62859
-----------------------------------------------------------------------------
I made a few improvements. Change the trig functions from radians to degrees.
Added windows clipboard functions. Added stuff keyboard functions.
------------------------------------------------------------------------------
$ENDIF

$OPTION CNTLBREAK OFF
$LIB ALL OFF
$LIB FULLFLOAT ON
$ERROR ALL OFF

DEFINT A-Z
DECLARE FUNCTION GetStrLoc(BYVAL AllocHandle%) AS LONG
DECLARE SUB Infix2PostFix(InFix$(),InFixNum%,PostFix$(),PostNum%)
DECLARE FUNCTION LineEdit$(Text$,Bracket1$,Bracket2$,Fill%,Row%,Col%,ViewWidth%,Fg%,Bg%,CursorFg%,CursorBg%)

  'Use these equates to make the REG statement more readable:
  %AX = 1 : %BX = 2 : %CX = 3 : %DX = 4
  %SI = 5 : %DI = 6 : %BP = 7 : %DS = 8
  %ES = 9 : %FLAGS = 0

%Enter = 13:%BackSpace = 8:%Escape=27
%HomeKey = -71:%EndKey = -79:%InsertKey = -82:%DeleteKey = -83
%LeftArrow = -75:%RightArrow = -77
Escape$ = chr$(27)
SHARED Escape$
%FALSE = 0
%TRUE = 1

DIM Infix$(30),Rpn$(100),Precedence$(60),Precedence%(60),Stack$(100),CalcStack@@(100)
SHARED Precedence$(),Precedence%(),PrecdenceTotal%,Stack$(),StackPos%,CalcStack@@()
DIM Functions$(10)
SHARED Functions$(),Ky$,ErrorVal%,KeyCode%

x& = SETMEM(-700000)          ' release unused memory

POPUP KEY CHR$(8,68,247)        ' ALT-F10 is hot key

POPUP MULTIPLEX &HC456,9254   ' reg AX and DX get this pattern as an ID
REG 1, &HC456 : REG 4,9254    ' set pattern to check for already installed
CALL INTERRUPT &H2F           ' do the multiplex interrrupt
IF REG(1) <> &HC456 AND REG(4) <> 9254 THEN Installed:END 'we were already installed

SwapFile$ = LEFT$(CURDIR$,2)+"\Calulate.SWP"
ON ERROR GOTO FoundError

PRINT "TSR Calulator"
PRINT "Press ALT-F10 To Popup"
PRINT "Press ALT-F10 To Stuff answer to keyboard
PRINT "Press CTRL-F10 TO send answer to clipboard"
PRINT "Popping down now . . ."

REG 1, &HC454 : REG 4,9252  ' Alter AX,DX to show we were here

popdown:
POPUP SLEEP USING EMS, SwapFile$       ' before going to sleep
trigger = POPUP(4)
IF trigger <> 1 THEN GOTO popdown

WHILE 1=1
        x% = POS : y% = CSRLIN
        DEF SEG = &hB800
        SaveScreen$ = PEEK$(0,4000) ' save the entire screen
        IF REG(1) = &HC456 AND REG(4) = 9254 THEN
                CLS
                LOCATE 8,20
                PRINT "+-------------------------------------+";
                LOCATE 9,20
                PRINT "| Tsr Calulator is already installed  |";
                LOCATE 10,20
                PRINT "+-------------------------------------+";
        ELSE
                GOSUB GetOpData
                GOSUB Calculate
                IF KeyCode% = -113 THEN
                        EmptyBuffer
                        POPUP key Off
                        Keyboard.Off
                        KeyStuff Answer$
                        POPUP key on
                        KeyBoard.On
                END IF
        END IF
        POKE$ 0, SaveScreen$
        LOCATE y%, x%,1        'restore screen
	REG 1, &HC454 : REG 4,9252  ' Alter AX,DX to show we were here
        POPUP SLEEP                 ' before going to sleep
WEND

Calculate:
LOCATE 25,2
'PRINT STRING$(78,32);
Text$ = STRING$(64,32)
DO
	LOCATE 24,2,1
	PRINT " Expression ? ";STRING$(64,32);
	Text$ = LineEdit$(Text$," ","",32,24,15,64,7,0,7,0)
	Expression$ = UCASE$(Text$) + ":"
	IF KeyCode% <> 27 THEN GOSUB ReturnAnswer
	IF KeyCode% = -103 AND Clipboard.Detect% THEN Clipboard.PutText Answer$, ErrCode%
LOOP UNTIL KeyCode% = 27 OR KeyCode% = -113
RETURN

ReturnAnswer:
ErrorVal% = 0
Break.Up.Expression Expression$,Infix$(),InfixNum%
Infix2PostFix Infix$(),InFixNum%,Rpn$(),RpnNum%

'PRINT "Reverse Polish Notion = ";
'FOR I% = 1 TO RpnNum%
'	PRINT Rpn$(I%);" ";
'NEXT I%
'SLEEP
'RETURN
Answer@@ = EVAL@@(Rpn$(),RpnNum%)
LOCATE 25,2
IF ErrorVal% THEN
	PRINT " Error in Expression !";"               "
ELSE
	PRINT " Answer:";Answer@@;"                     ";
END IF
Answer$ = STR$(Answer@@)
RETURN

SUB Infix2PostFix(InFix$(),InFixNum%,PostFix$(),PostNum%) PUBLIC
StackPos% = 0
PostNum% = 0
FOR I% = 1 TO InFixNum%
	Op$ = InFix$(I%)
	IF Operator%(Op$) THEN
                SELECT CASE Op$
                 CASE "("                ' IF ( Simply Push on Stack
			PushStack Op$
                 CASE  ")"               ' Pop Operators off stack till )
                	WHILE Stack$(StackPos%-1) <> "("
		                INCR PostNum%
		        	PostFix$(PostNum%) = PopStack$
                        WEND
			PopStack$
                 CASE "-"
                        IF I% = 1 OR (Operator%(InFix$(I%-1)) AND _
                        InFix$(I%-1) <> ")") THEN
	         		Op$ = "-%"          'Uniary Minus
                        ELSE
                               	GOTO ProcedeMinusPlus
			END IF
			PushStack  Op$              'Push Directly on stack
                 CASE "+"
                        IF I% = 1 OR (Operator%(InFix$(I%-1)) AND _
                        InFix$(I%-1) <> ")") THEN
                       		Op$ = "+%"          'Uniary Plus
			ELSE
                               	GOTO ProcedeMinusPlus
                        END IF
                	PushStack  Op$              'Push Directly on stack
                 CASE "SIN","COS","TAN","SQR","ROUND","EXP","EXP2","EXP10", _
                 "FRAC","LOG","LOG2","LOG10","ABS","ARCSIN","ARCOS","ARCTAN"
                	PushStack Op$
                 CASE ELSE
ProcedeMinusPlus:
                        WHILE PrecedenceStack% >= OpPrecedence%(Op$)
		                INCR PostNum%
		        	PostFix$(PostNum%) = PopStack$
	                WEND
	                IF Op$ <> "," THEN PushStack Op$
         	END SELECT
	ELSE
                INCR PostNum%
        	PostFix$(PostNum%) = Op$    'Put Operands in Rpn Stack
        END IF
NEXT I%
EXIT SUB

END SUB

SUB PushStack(Op$)
Stack$(StackPos%) = Op$
INCR StackPos%
END SUB

FUNCTION PopStack$()
DECR StackPos%
IF StackPos% < 0 THEN
	ErrorVal% = 1
ELSE
	PopStack$ = STACK$(StackPos%)
	STACK$(StackPos%) = ""
END IF
END FUNCTION

FUNCTION PrecedenceStack%()
IF StackPos% > 0 THEN
	ARRAY SCAN Precedence$(1) FOR PrecdenceTotal%,= Stack$(StackPos%-1),TO Found%
	IF Found% > 0 THEN
		PrecedenceStack% = Precedence%(Found%)
	ELSE
		PrecedenceStack% = -1
	END IF
ELSE
	StackPrecedence% = -1
END IF
END FUNCTION


FUNCTION OpPrecedence%(Op$)

ARRAY SCAN Precedence$(1) FOR PrecdenceTotal%,=Op$,TO Found%
IF Found% > 0 THEN
	OpPrecedence% = Precedence%(Found%)
ELSE
	OpPrecedence% = -1
END IF
END FUNCTION

FUNCTION Operator%(Op$)
ARRAY SCAN Precedence$(1) FOR PrecdenceTotal%,=Op$,TO Found%
IF Found% THEN Operator% = 1
END FUNCTION

FUNCTION EVAL@@(Rpn$(),RpnNum%)
StackPos% = 0
FOR I% = 1 TO RpnNum%
	IF Operator%((Rpn$(I%))) THEN
		SELECT CASE Rpn$(I%)
		 CASE "+"
			A@@ = PopVal@@
			Result@@ = A@@ + PopVal@@
			PushVal Result@@
		 CASE "-"
			A@@ = PopVal@@
			Result@@ = A@@ - PopVal@@
			PushVal Result@@
		 CASE "*"
			A@@ = PopVal@@
			Result@@ = A@@ * PopVal@@
			PushVal Result@@
		 CASE "/"
			A@@ = PopVal@@
			Result@@ = A@@ / PopVal@@
			PushVal Result@@
		 CASE "-%"
			Result@@ = -PopVal@@
			PushVal Result@@
		 CASE "+%"
			Result@@ = +PopVal@@
			PushVal Result@@
		 CASE "^"
			A@@ = PopVal@@
			Result@@ = PopVal@@ ^ A@@
			PushVal Result@@
		 CASE  "SIN"
			Result@@ = SIN(DegreesToRadians(PopVal@@))
			PushVal Result@@
		 CASE   "COS"
			Result@@ = COS(DegreesToRadians(PopVal@@))
			PushVal Result@@
		 CASE   "TAN"
			Result@@ = TAN(DegreesToRadians(PopVal@@))
			PushVal Result@@
		 CASE   "ARCTAN"
			Result@@ = RadiansToDegrees(ATN(PopVal@@))
			PushVal Result@@
		 CASE   "ARCSIN"
			Result@@ = RadiansToDegrees(ARCSIN(PopVal@@))
			PushVal Result@@
		 CASE   "ARCOS"
			Result@@ = RadiansToDegrees(ArcCos@@(PopVal@@))
			PushVal Result@@
		 CASE   "SQR"
			Result@@ = SQR(PopVal@@)
			PushVal Result@@
		 CASE   "EXP2"
			Result@@ = EXP(PopVal@@)
			PushVal Result@@
		 CASE   "EXP10"
			Result@@ = EXP10(PopVal@@)
			PushVal Result@@
		 CASE   "LOG"
		 	Result@@ = LOG(PopVal@@)
			PushVal Result@@
		 CASE   "LOG2"
			Result@@ = LOG2(PopVal@@)
			PushVal Result@@
		 CASE   "LOG10"
			Result@@ = LOG10(PopVal@@)
			PushVal Result@@
		 CASE   "ABS"
			Result@@ = ABS(PopVal@@)
			PushVal Result@@
		END SELECT
	ELSE
		Result@@ = VAL(Rpn$(I%))
		PushVal Result@@
	END IF
NEXT I%
IF StackPos% >1 OR StackPos% < 0 THEN
	EVAL@@ = 0
        ErrorVal% = 1
ELSE
	EVAL@@ = PopVal@@
END IF
END FUNCTION

FUNCTION DegreesToRadians@@(BYVAL Degrees@@) PUBLIC
FUNCTION = Degrees@@ * 1.74532925199433E-2@@
END FUNCTION

FUNCTION RadiansToDegrees@@(BYVAL Radians@@) PUBLIC
FUNCTION = Radians@@ * 57.2957795130823@@
END FUNCTION

FUNCTION ArcCos@@(BYVAL Value@@) PUBLIC
FUNCTION = 1.570796326794895@@ - ArcSin@@(Value@@)
END FUNCTION

FUNCTION ArcSin@@(BYVAL Value@@) PUBLIC
FUNCTION = ATN(Value@@ / SQR(1@@ - Value@@ * Value@@))
END FUNCTION

SUB PushVal(Result@@)
CalcStack@@(StackPos%) = Result@@
INCR StackPos%
END SUB

FUNCTION PopVal@@()
DECR StackPos%
IF StackPos% < 0 THEN
	ErrorVal% = 1
ELSE
	PopVal@@ = CalcStack@@(StackPos%)
	CalcStack@@(StackPos%) = 0
END IF
END FUNCTION

GetOpData:
RESTORE OpData
I% = 0
DO
        INCR I%
        READ Precedence$(I%)
LOOP UNTIL Precedence$(I%-1) = "99"
PrecdenceTotal% = I% -1

RESTORE OpPrecData
FOR I% = 1 TO PrecdenceTotal%
        READ Precedence%(I%)
NEXT I%
RETURN

SUB Break.Up.Expression ( Expression$,Infix$(),InfixTotal%) Public
'-----------------------------------------------------------------------------
'
'    Breaks up the Expression into Tokens
'    Infix$() = an ARRAY of the elements in the Expression
'    InfixTotal% = Number Tokens found
'
'-----------------------------------------------------------------------------
DIM StringChar AS STRING * 1
Ln = LEN(Expression$)
CharPos = 0
Letters% = 0
BeginWord% = 1
InfixTotal% = 1
SearchChars$ = ":.,()+-*/\^" + "0123456789"

ThisLinePtr = STRPTR32(ThisLine$)

DO
    INCR CharPos%
    StringChar$ = MID$(UCASE$(Expression$),CharPos%,1)
    SELECT CASE StringChar$
     CASE ".","0","1","2","3","4","5","6","7","8","9"
        IF Letters% = 0 THEN BeginWord = CharPos%
        Letters% = 1
     CASE "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P", _
     "Q","R","S","T","U","V","W","X","Y","Z"
        IF Letters% = 0 THEN BeginWord = CharPos%
        Letters% = 1
     CASE " "
        IF Letters% = 1 THEN
                WordLen% = CharPos% - BeginWord%
                Infix$(InfixTotal%) = MID$(Expression$,BeginWord%,WordLen%)
                INCR InfixTotal%
                BeginWord = CharPos%
        END IF
        Letters% = 0
     CASE "," , "(", ")" , "+" , "-" , "*" , "/" , "\" ,"^",":"
        IF Letters% = 1 THEN
                WordLen% = CharPos - BeginWord%
                Infix$(InfixTotal%) = MID$(Expression$,BeginWord%,WordLen%)
                INCR InfixTotal%
                BeginWord = CharPos
                Letters% = 0
        END IF
        Infix$(InfixTotal%) = StringChar$
        INCR InfixTotal%
    END SELECT
LOOP UNTIL CharPos >= Ln
DECR InfixTotal%
END SUB

FUNCTION CenterLineEdit$(Text$, Bracket1$,Bracket2$,Fill%,Row%, ViewWidth%,Fg%,Bg%,CursorFg%,CursorBg%) PUBLIC
 CenterPos% = INT((80 - (ViewWidth%+2)) / 2 + .5 +1)
 CenterLineEdit$ = LineEdit$(Text$, Bracket1$,Bracket2$,Fill%,Row%, CenterPos%, ViewWidth%,Fg%,Bg%,CursorFg%,CursorBg%)
END FUNCTION

FUNCTION LineEdit$(Text$, Bracket1$,Bracket2$,Fill%,Row%, Col%, ViewWidth%,Fg%,Bg%,CursorFg%,CursorBg%) PUBLIC
 EmptyBuffer
 FLEXCHR$ = CHR$(Fill%)
 Work$ = Text$
 Vieu$ = STRING$(ViewWidth%, Fill%)
 LineLen% = LEN(Work$)
 Cursor% = 1
 BasePos% = Col%+1
 WindowStart% = 1
 InsertKey% = 1
 FirstKey% = 1
 DO
    IF Cursor% > ViewWidth% THEN WindowStart% = Cursor% - ViewWidth%
    LSET Vieu$ = MID$(Work$,WindowStart%,ViewWidth%)
    CPRINT Fg%,Bg%,Row%,Col%,Bracket1$+Vieu$+Bracket2$
    COLOR CursorFg%,CursorBg%
    IF InsertKey% THEN
      LOCATE ,BasePos%+Cursor%-WindowStart%,1, 12, 14
    ELSE
      LOCATE ,BasePos%+Cursor%-WindowStart%,1, 0, 7
    END IF
    COLOR Fg%,Bg%
    LineLen% = LEN(Work$)
    KeyPressed
    KeyCode% = ASCII(Ky$): IF KeyCode% = 0 THEN KeyCode% = -ASCII(MID$(Ky$, 2))
    LOCATE,, 0
    IF FirstKey% THEN
      SELECT CASE KeyCode%
       CASE 32 TO 255,%DeleteKey
         Work$ = ""
         Cursor% = 1
      END SELECT
      FirstKey% = 0
    END IF
    SELECT CASE KeyCode%
    CASE 32 TO 255      ' letter keys
         IF InsertKey% THEN
                Work$ = Left$(Work$,Cursor%-1) + Ky$ + MID$(Work$,Cursor%)
                INCR Cursor%
         ELSE
                IF Cursor% <= LineLen% THEN
                	MID$(Work$,Cursor%,1) = Ky$
                	INCR Cursor%
                ELSE
                  Work$ = Work$ + Ky$
                  INCR Cursor%
                END IF
         END IF
    CASE %Enter
       LineEdit$ = Work$
       EXIT FUNCTION
    CASE %BackSpace
       IF Cursor% > 1 AND Cursor% <= LineLen% +1 THEN
          Work$ = Left$(Work$,Cursor% - 2) + MID$(Work$,Cursor%)
          DECR Cursor%
       END IF
    CASE %Escape
          LineEdit$ = ""
          EXIT FUNCTION
    CASE -103
          LineEdit$ = Work$
          EXIT FUNCTION
    CASE -113
          LineEdit$ = Work$
          EXIT FUNCTION
    CASE %LeftArrow
          IF Cursor% > 1 THEN DECR Cursor%
    CASE %RightArrow
          IF Cursor% < LineLen% + 1 THEN INCR Cursor%
    CASE %HomeKey
         Cursor% = 1
    CASE %EndKey
         Cursor% = LineLen% + 1
    CASE %InsertKey
       InsertKey% = ISFALSE InsertKey%
    CASE %DeleteKey
          Work$ = LEFT$(Work$, Cursor% - 1) + MID$(Work$, Cursor% + 1)
    END SELECT
 LOOP
END FUNCTION

SUB EmptyBuffer()
 DO
 LOOP UNTIL INKEY$ = ""
END SUB

SUB KeyPressed PUBLIC
DO
 Ky$ = INKEY$
LOOP UNTIL Ky$ <> ""
END SUB

SUB CPRINT(FG%,BG%,Row%, Col%,Txt$) PUBLIC
 COLOR FG%, BG%
 LOCATE Row%, Col%,0
 PRINT Txt$;
END SUB

SUB Installed()
        x% = POS : y% = CSRLIN
        DEF SEG = &hB800
        SaveScreen$ = PEEK$(0,4000) ' save the entire screen
                CLS
                LOCATE 8,20
                PRINT "+-------------------------------------+";
                LOCATE 9,20
                PRINT "| Tsr Calulator is already installed  |";
                LOCATE 10,20
                PRINT "+-------------------------------------+";
        A$ = INPUT$(1)
        POKE$ 0, SaveScreen$
        LOCATE y%, x%,1        'restore screen
END SUB

FUNCTION Clipboard.Detect%
'Carl Gorringe 1/15/96
'PUBLIC DOMAIN
ClipMode% = %False
WinMode% = Info.WinMode%
IF WinMode% > 1 THEN
  REG %AX, &H1700
  CALL INTERRUPT &H2F
  IF REG(%AX) = &H1700 THEN
         ClipMode% = %False
  ELSE
         ClipMode% = %True
  END IF
END IF
Clipboard.Detect% = ClipMode%
END FUNCTION

SUB Clipboard.Empty (ErrCode%)
'Carl Gorringe 1/15/96
'PUBLIC DOMAIN

'--- Open Clipboard ---
	REG %AX, &H1701
	CALL INTERRUPT &H2F
	IF REG(%AX) = 0 THEN
		ErrCode% = 1                  '<-- Clipboard is already open (error)
		EXIT SUB
	END IF

'--- Empty Clipboard ---
	REG %AX, &H1702
	CALL INTERRUPT &H2F
	IF REG(%AX) = 0 THEN
		ErrCode% = 3                  '<-- Failure (error)
	END IF

'--- Close Clipboard ---
	REG %AX, &H1708
	CALL INTERRUPT &H2F
	IF REG(%AX) = 0 THEN
		ErrCode% = 2                  '<-- Clipboard wont close (error)
		EXIT SUB
	END IF

END SUB
 
SUB Clipboard.Put (Format%, DataSeg%, DataOff%, DataSize&, ErrCode%)
'Carl Gorringe 1/15/96
'PUBLIC DOMAIN
 
'--- Open Clipboard ---
	REG %AX, &H1701
	CALL INTERRUPT &H2F
	IF REG(%AX) = 0 THEN
		ErrCode% = 1                  '<-- Clipboard is already open (error)
		EXIT SUB
	END IF
 
'--- Store Clipboard Data ---
	REG %AX, &H1703
	REG %DX, Format%
	REG %ES, DataSeg%
	REG %BX, DataOff%
	IF DataSize& < 32768 THEN
		REG %SI, 0
		REG %CX, DataSize&
	ELSE
		REG %SI, (DataSize& \ 32768) * 2048   '<-- This part NOT Tested!
		REG %CX, DataSize& MOD 32768          '<-- but don't worry about it.
	END IF
 
	CALL INTERRUPT &H2F
	IF REG(%AX) = 0 THEN
		ErrCode% = 3                  '<-- (error)
	END IF

'--- Close Clipboard ---
	REG %AX, &H1708
	CALL INTERRUPT &H2F
	IF REG(%AX) = 0 THEN
		ErrCode% = 2                  '<-- Clipboard wont close (error)
		EXIT SUB
	END IF
 
END SUB

SUB Clipboard.PutText (Text249$ , ErrCode%)
'Carl Gorringe 1/15/96
'PUBLIC DOMAIN
ErrCode% = 0
'--- Empty Clipboard ---
	CALL Clipboard.Empty(ErrCode%)
	IF ErrCode% <> 0 THEN
		ErrCode% = ErrCode% + 10
		EXIT SUB
	END IF
'--- Store Text on to Clipboard ---
	Temp$ = Text249$ + CHR$(0)
	TempLen& = LEN(Temp$)
	CALL Clipboard.Put(1, STRSEG(Temp$), STRPTR(Temp$), TempLen&, ErrCode%)
	CALL Clipboard.Put(7, STRSEG(Temp$), STRPTR(Temp$), TempLen&, ErrCode%)
END SUB
 
FUNCTION Info.WinMode%
'Carl Gorringe 1/15/96
'PUBLIC DOMAIN
'-------------------------------------------------------------
'  Returns the current Windows Mode:
'    0 = Windows not detected
'    1 = Real mode detected (Win 3.0 and earlier only)
'    2 = Standard mode detected. (Win 3.11 and earlier only)
'    3 = 386 enhanced mode detected.
'-------------------------------------------------------------
DOSver% = Info.DOSver%
IF DOSver% >= 300 THEN
  REG %AX, &H160A
  CALL INTERRUPT &H2F
  IF REG(%AX) <> 0 THEN
	 WinMode% = 0
  ELSE
	 WinMode% = REG(%CX)
  END IF
END IF
Info.WinMode% = WinMode%
END FUNCTION
 
FUNCTION Info.DOSver%
'Carl Gorringe 1/15/96
'PUBLIC DOMAIN

REG %AX, &H3306
CALL INTERRUPT &H21
DOSver% = ((REG(%BX) AND 255) * 100) + (REG(%BX) \ 256)
IF DOSver% = 0 THEN
  REG %AX, &H3000
  CALL INTERRUPT &H21
  DOSver% = ((REG(%AX) AND 255) * 100) + (REG(%AX) \ 256)
END IF

Info.DOSver% = DOSver%

END FUNCTION

SUB KeyStuff(StuffString$) public
POPUP stuff StuffString$,0,0
POPUP KEY OFF
POPUP TIMER 1
DO
  POPUP SLEEP
LOOP UNTIL POPUP(3) = 256
POPUP TIMER OFF
POPUP STUFF OFF
END SUB

SUB KEYBOARD.ON
! in al,&H21
! and al,&B11111101
! out &H21,al
END SUB

SUB KEYBOARD.OFF
! in al,&H21
! or al,&B00000010
! out &H21,al
END SUB

FoundError:
ErrorVal% = 1
RESUME NEXT

 OpData:
 DATA "", ":" , "(", ")"
 DATA  "+", "-", "-%","+%","*", "/","\","^","SIN","COS",","
 DATA "TAN","ARCSIN","ARCOS","ARCTAN","SQR","EXP2","EXP10"
 DATA "LOG","LOG2","LOG10","ABS","99"

 OpPrecData:
 DATA  0,  1  ,  2 ,  3
 DATA  4 ,  4 ,   8 , 8  , 6 ,  6 , 6 , 7 ,  4  , 4   , 3
 DATA   4  ,   4    ,   4   ,   4    ,  4  ,  4   ,  4
 DATA  4  ,  4   ,   4   ,  4  , 4
